/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *  toppers/s_record.cpp
 */
#include "toppers/s_record.hpp"
#include <istream>
#include <algorithm>
#include <cctype>
#include <cstring>

namespace toppers
{

  /*!
   *  \brief  S쥳ɤΥ
   *  \param  istr  ϥȥ꡼
   */
  void s_record::load( std::istream& istr )
  {
    int type = -1;

    while ( istr )
    {
      std::string buf;
      std::getline( istr, buf );
      if ( buf.empty() )
      {
        break;
      }
      record rec = read_record( buf );

      // ޤ긷̩ˤϽʤ
      if ( '1' <= rec.type && rec.type <= '3' )
      {
        bool done = false;
        typedef std::vector< value_type >::iterator iterator;
        for ( iterator iter( data_.begin() ), last( data_.end() ); iter != last; ++iter )
        {
          if ( rec.address == iter->first + iter->second.size() )
          {
            std::copy( rec.data.begin(), rec.data.end(), std::back_inserter( iter->second ) );
            done = true;
          }
        }
        if ( !done )
        {
          data_.push_back( value_type( rec.address, std::vector< unsigned char >( rec.data.begin(), rec.data.end() ) ) );
        }
      }
      type = rec.type;
    }

    cache_ = data_.begin();
  }

  /*!
   *  \brief  ꥢɥ쥹ΥХȥǡ
   *  \param  address   ɥ쥹
   *  \return address ǻꤷɥ쥹ΥХȥǡ֤
   */
  int s_record::operator[]( size_type address ) const
  {
    typedef std::vector< value_type >::const_iterator const_iterator;
    if ( cache_ != data_.end() )
    {
      const_iterator iter( cache_ );
      if ( iter->first <= address && address < iter->first + iter->second.size() )
      {
        return iter->second.at( address - iter->first );
      }
    }
    for ( const_iterator iter( cache_ ), last( data_.end() ); iter != last; ++iter )
    {
      if ( iter->first <= address && address < iter->first + iter->second.size() )
      {
        cache_ = iter;
        return iter->second.at( address - iter->first );
      }
    }
    for ( const_iterator iter( data_.begin() ), last( cache_ ); iter != last; ++iter )
    {
      if ( iter->first <= address && address < iter->first + iter->second.size() )
      {
        cache_ = iter;
        return iter->second.at( address - iter->first );
      }
    }
    return -1;
  }

  /*!
   *  \brief  S쥳ɤ߹
   *  \param  base  ɤ߹֤߰Ƭɥ쥹
   *  \param  size  ͤΥХȿ
   *  \param  little_endian ȥ륨ǥʤ trueӥåǥʤ false 
   *  \return ɤ߹֤ͤ
   */
  boost::uintmax_t s_record::get_value( std::size_t base, std::size_t size, bool little_endian ) const
  {
    boost::uintmax_t value = 0;
    if ( little_endian )
    {
      for ( long j = static_cast< long >( size-1 ); j >= 0; j-- )
      {
        int t = ( *this )[ base + j ];
        if ( t < 0 )
        {
          throw data_error();
        }
        value = ( value << 8 ) | ( t & 0xff );
      }
    }
    else
    {
      for ( std::size_t j = 0; j < size; j++ )
      {
        int t = ( *this )[ base + j ];
        if ( t < 0 )
        {
          throw data_error();
        }
        value = ( value << 8 ) | ( t & 0xff );
      }
    }
    return value;
  }

  unsigned long s_record::lower_bound() const
  {
    return data_.front().first;
  }

  unsigned long s_record::upper_bound() const
  {
    return data_.back().first + data_.back().second.size();
  }

  /*!
   *  \brief  S쥳ɤΣɤ߹
   *  \param  rec_buf ԥХåե
   *  \return ɤ߹߷̤֤
   */
  s_record::record const s_record::read_record( std::string const& rec_buf )
  {
    std::string buf( rec_buf );

    // '\r'ޤ'\n'αƤк
    while ( std::isspace( static_cast< unsigned char >( *buf.rbegin() ) ) )
    {
      buf = buf.substr( 0, buf.size()-1 );
    }

    if ( buf.size() < 10 || buf[0] != 'S' )
    {
      throw format_error();
    }
    int ch = static_cast< unsigned char >( buf[1] );
    int address_length = 4;
    std::string::size_type size = buf.size();

    switch ( ch )
    {
    case '1':
    case '9':
      address_length = 4;
      break;
    case '2':
    case '8':
      address_length = 6;
      break;
    case '3':
    case '7':
      address_length = 8;
      break;
    default:
      if ( !std::isdigit( static_cast< unsigned char >( ch ) ) )
      {
        throw format_error();
      }
      break;
    }
    
    record rec;
    rec.type = ch;
    rec.length = xdigit_to_int( buf[2] ) << 4 | xdigit_to_int( buf[3] );
    if ( rec.length * 2u + 4 != buf.size() )
    {
      throw format_error();
    }
    rec.length -= address_length/2 + 1; // ɥ쥹ȥåĹơǡĹľ

    rec.address = 0;
    int base = 4;
    for ( int i = 0; i < address_length; i++ )
    {
      rec.address = rec.address << 4 | xdigit_to_int( buf[base+i] );
    }

    base += address_length;
    rec.data.reserve( rec.length );
    for ( int i = 0; i < rec.length; i++ )
    {
      rec.data.push_back( static_cast< unsigned char >( xdigit_to_int( buf[base+i*2] ) << 4 | xdigit_to_int( buf[base+i*2+1] ) ) );
    }

    rec.checksum = xdigit_to_int( buf[size-2] ) << 4 | xdigit_to_int( buf[size-1] );

    // åȽϾά

    return rec;
  }

  /*!
   *  \brief  ϻʿͤؤѴ
   *  \param  ch  ϻʿʸ
   *  \return ch б
   */
  int s_record::xdigit_to_int( int ch )
  {
    static char const xdigits[] = "0123456789abcdef";

    ch = std::tolower( static_cast< unsigned char >( ch ) );
    char const* s = std::strchr( xdigits, ch );
    if ( s == 0 )
    {
      return -1;
    }
    return s - xdigits;
  }

}
